{$DEFINE DLLmode} {Switch from Delphi Unit call to DLL procedure call}
unit MainWindow;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls,
     Forms, Dialogs, StdCtrls, Grids, WaitMsg, ComCtrls;

{!! FOR CUSTOMIZED DLL, remember:
(1) to correct UseDLLName 'y1d5n???.dll' below;
(2) to correct array limits below: BoxMax, BoxGrMax, CntMax, CntGrMax;
(3) to define proper RegCustomer/RegPassword in Initialization section;
(4) to correct Optimizer Settings, see procedure DefaultSettings below}

const UseDLLName = 'y1d5x_aa.dll';
      CellBad = -55555;  StockCheck = 555;  PartCheck = 777;
                       { WarnMsgs = true; {- Test program input checks}
                         WarnMsgs =false; {- .dll internal checks only}
type
  TMainForm = class(TForm)
    RunButton: TButton;
    StockButton: TButton;
    PartButton: TButton;
    VerButton: TButton;
    RunTextsButton: TButton;
    CloseBut: TButton;
    CntGrid: TStringGrid;
    BoxGrid: TStringGrid;
    ResultGrid: TStringGrid;
    ArrBoxGrid: TStringGrid;
    ArrCntGrid: TStringGrid;
    StockTotEd: TEdit;
    PartTotEd: TEdit;
    ErrLab: TLabel;
    CritLab: TLabel;
    UtilLab: TLabel;
    WstLab: TLabel;
    CostLab: TLabel;
    LastNoLab: TLabel;
    LastWstLab: TLabel;
    LeftLab: TLabel;
    ContLab: TLabel;
    VolLab: TLabel;
    SawLab: TLabel;
    EndLab: TLabel;
    LayCutLab: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    RadioButtonB: TRadioButton;
    RadioButtonG: TRadioButton;
    RadioButtonSRS: TRadioButton;
    IniExEdit: TEdit;
    IniExUpDown: TUpDown;
    ExamplLab: TLabel;
    procedure GridHeaders;
    procedure ClearResultGrids;
    procedure DefaultTotals(C,B :boolean);
    procedure DefaultCells(C,B :boolean);
    procedure DefaultSettings;
    procedure ExampleCells(IniExample :integer);
    procedure InputExample(IniExample :integer);
    procedure ClearY1DCallVarsDLL;
    function ReadGridGroups :boolean;
    function UnGroupInput :boolean;
    procedure OpenLayouts;
    procedure RunButtonClick(Sender: TObject);
    procedure StockButtonClick(Sender: TObject);
    procedure PartButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure VerButtonClick(Sender: TObject);
    procedure RunTextsButtonClick(Sender: TObject);
    procedure IniExUpDownClick(Sender: TObject; Button: TUDBtnType);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm    :TMainForm;
  CallMode    :integer;  {CallMode = 0/1, 0 - Y1DPackG, group arrays,
                      see CM-0/CM-1 marks, 1 - Y1DPackB, line arrays}
  SRSCallMode :integer;                   {0 - Common DLL call mode,
                                           1 - Stock Range Scan mode}
implementation

{$IFNDEF DLLmode}         {Unit Const, Types, Vars can't be reached.}
uses y1dsc, y1srs, y1cust; {Below data must be identical to DLL/Unit,}
{$ELSE DLLmode}           {.. except for "external..." declarations.}

  type  lint = longint;  {4 byte int - Most of DLL arguments}
        rint = smallint; {2 byte int - Item No DLL arguments}

{========================== DLL constants, types, arguments copy ===}
                {$IFDEF FreeVer}
  const BoxGrMax =  20;  BoxMax = 100;
        CntGrMax =  10;  CntMax = 100; {DLL/EXE Free Version =ArrMax}
                {$ELSE FreeVer}
{$IFNDEF MassVer}
  const BoxGrMax =1000;  BoxMax =5000;
        CntGrMax = 100;  CntMax =5000; {DLL/EXE Working vers =ArrMax}
{$ELSE MassVer}
  const BoxGrMax =2000; BoxMax =20000;
        CntGrMax = 100; CntMax =20000; {DLL/EXE Mass version =ArrMax}
{$ENDIF MassVer}{$ENDIF FreeVer}

                         A1 = 0; {Array Base}
type  BoxArrL   = array [A1..BoxMax+1]                of lint;
      BoxArrS   = array [A1..BoxMax+1]                of rint;
      CntArrL   = array [A1..CntMax+1]                of lint;
      CntArrS   = array [A1..CntMax+1]                of rint;
      BoxGrArrL = array [A1..BoxGrMax+1]              of lint;
      BoxGrArrS = array [A1..BoxGrMax+1]              of rint;
      CntGrArrL = array [A1..CntGrMax+1]              of lint;
      CntGrArrS = array [A1..CntGrMax+1]              of rint;

procedure Y1DPackG5(
               var ErrorNumb, ErrorMsgs :lint; {Groupped CallMode-0}
               RegCustomer              :PChar; {char* for C++..}
               RegPassword,            {..ByVal As String for VB}
    {settings} CostOptim, IgnoreLast,
               Intensity, ReduceLays, PrefShort,
               DiffStocks, DiffPieces, MaxPieces,
               StockBundle, ReusLength, ReusAbility,
               GapItIt, GapItEnd, GapGripEnd,
               OptimTime, IterMult, LayByMark,
               RunMsgMode, ReservInp4, ReservInp3,
               ReservInp2, ReservInp1    :lint;
       {input} var StockGrLth            :CntGrArrL;            {CM-0}
               var StockGrCst            :CntGrArrL;            {CM-0}
               var StockGrQty            :CntGrArrS;            {CM-0}
               var PartGrLth             :BoxGrArrL;            {CM-0}
               var PartGrMrkID           :BoxGrArrL;            {CM-0}
               var PartGrQty             :BoxGrArrS;            {CM-0}
      {output} var Critsum, Effsum,
               StockSum, PartSum,
               LengthSum, WasteSum, CostSum,
               LastStockNo, LastParts,
               LastLength, LastWaste, LastCost,
               PatternSum, LayoutSum, LayoutCuts,
               ReservOut3, ReservOut2,
               ReservOut1                :lint;
               var StockGrNo             :CntArrS;              {CM-0}
               var PartGrNo              :BoxArrS;              {CM-0}
               var PartStockNo           :BoxArrS;
               var StockLayNo            :CntArrS;
               var StockPatNo            :CntArrS;
               var StockParts            :CntArrS;
               var StockWaste            :CntArrL);
stdcall; external UseDLLName;

procedure Y1DPackB5(
               var ErrorNumb, ErrorMsgs :lint;  {LineArr CallMode-1}
               RegCustomer              :PChar; {char* for C++..}
               RegPassword,            {..ByVal As String for VB}
    {settings} CostOptim, IgnoreLast,
               Intensity, ReduceLays, PrefShort,
               DiffStocks, DiffPieces, MaxPieces,
               StockBundle, ReusLength, ReusAbility,
               GapItIt, GapItEnd, GapGripEnd,
               OptimTime, IterMult, LayByMark,
               RunMsgMode, ReservInp4, ReservInp3,
               ReservInp2, ReservInp1    :lint;
       {input} var StockLength           :CntArrL;              {CM-1}
               var StockCost             :CntArrL;              {CM-1}
               var PartLength            :BoxArrL;              {CM-1}
               var PartMarkID            :BoxArrL;              {CM-1}
      {output} var Critsum, Effsum,
               StockSum, PartSum,
               LengthSum, WasteSum, CostSum,
               LastStockNo, LastParts,
               LastLength, LastWaste, LastCost,
               PatternSum, LayoutSum, LayoutCuts,
               ReservOut3, ReservOut2,
               ReservOut1                :lint;
               var PartStockNo           :BoxArrS;
               var StockLayNo            :CntArrS;
               var StockPatNo            :CntArrS;
               var StockParts            :CntArrS;
               var StockWaste            :CntArrL);
stdcall; external UseDLLName;

procedure Y1DScanG5(         {Stock Range Scan mode, SRSCallMode = 1}
               var ErrorNumb, ErrorMsgs :lint; {Groupped CallMode-0}
               RegCustomer              :PChar; {char* for C++..}
               RegPassword,            {..ByVal As String for VB}
    {settings} CostOptim, IgnoreLast,
               Intensity, ReduceLays, PrefShort,
               DiffStocks, DiffPieces, MaxPieces,
               StockBundle, ReusLength, ReusAbility,
               GapItIt, GapItEnd, GapGripEnd,
               OptimTime, IterMult, LayByMark,
               RunMsgMode, ReservInp4, ReservInp3,
               ReservInp2, ReservInp1    :lint;
               var StockGrLth            :CntGrArrL;
               var StockGrCst            :CntGrArrL;
               var StockGrQty            :CntGrArrS;
               var PartGrLth             :BoxGrArrL;
               var PartGrMrkID           :BoxGrArrL;
               var PartGrQty             :BoxGrArrS;
      {output} var Critsum, Effsum,
               StockSum, PartSum,
               LengthSum, WasteSum, CostSum,
               LastStockNo, LastParts,
               LastLength, LastWaste, LastCost,
               PatternSum, LayoutSum, LayoutCuts,
               ReservOut3, ReservOut2,
               ReservOut1                :lint;
               var StockGrNo             :CntArrS;
               var PartGrNo              :BoxArrS;
               var PartStockNo           :BoxArrS;
               var StockLayNo            :CntArrS;
               var StockPatNo            :CntArrS;
               var StockParts            :CntArrS;
               var StockWaste            :CntArrL);
stdcall; external UseDLLName;

{========================= /DLL constants, types, arguments copy ===}

procedure Y1DisplayVersion; external UseDLLName;
                            {To check current DLL version and limits}
procedure Y1DRunMessage(TextCaption, TextOptRun, TextEscAbort,
                TextCritTime :PChar); external UseDLLName;
procedure Y1DRunMessageSRS(TextCaption, TextOptRun, TextEscAbort,
                TextCritTime :PChar); external UseDLLName;
{$ENDIF DLLmode}            {To modify Run message caption and texts}

{------------------- Test1d_D5 program variables -------------------}

var  {input}               {Y1DPack* procedures call vars}
      ErrorNumb, ErrorMsgs      :lint;
      RegCustomer               :PChar; {char* for C++..}
      RegPassword,             {..ByVal As String for VB}
      CostOptim, IgnoreLast,               {0/1 booleans}
      Intensity, ReduceLays, PrefShort,    { Parameters }
      DiffStocks, DiffPieces, MaxPieces,
      StockBundle, ReusLength, ReusAbility,
      GapItIt, GapItEnd, GapGripEnd,
      OptimTime, IterMult, LayByMark,
      RunMsgMode, ReservInp4, ReservInp3,
      ReservInp2, ReservInp1,
      StockGrNmb, PartGrNmb     :lint;
      StockGrQty                :CntGrArrS;
      StockGrLth, StockGrCst    :CntGrArrL;
      PartGrQty                 :BoxGrArrS;
      PartGrLth, PartGrMrkID    :BoxGrArrL;
      StockLength, StockCost    :CntArrL;   {CallMode-1}
      PartLength, PartMarkID    :BoxArrL;   {CallMode-1}
     {output}
      Critsum, Effsum,
      StockSum, PartSum,
      LengthSum, WasteSum, CostSum,
      LastStockNo, LastParts,
      LastLength, LastWaste, LastCost,
      PatternSum, LayoutSum, LayoutCuts,
      ReservOut3, ReservOut2, ReservOut1,
      StockNumb, PartNumb       :lint; {Y1D actual Stock/PartNumb}

      PartStockNo               :BoxArrS;
      PartGrNo                  :BoxArrS;
      StockGrNo, StockLayNo,
      StockPatNo, StockParts    :CntArrS;
      StockWaste                :CntArrL;
      IniExample                :rint;
{$R *.DFM}
{----------------------------------------------------}
procedure TMainForm.GridHeaders;
var i : Integer;
begin
    with CntGrid do   begin
  ColWidths[0]:=37;
  for i:= 1 to ColCount - 1 do
  Cells[i,0]:= IntToStr(i);
  Cells[0,0]:= 'Type';
  Cells[0,1]:= 'Size';
  Cells[0,2]:= 'Qty';   end;

    with BoxGrid do           begin
  ColWidths[0]:=37;
  for i:= 1 to ColCount - 1 do
  Cells[i,0]:= IntToStr(i);
  Cells[0,0]:= 'Kind';
  Cells[0,1]:= 'Size';
  Cells[0,2]:= 'Qty';           end;

    with ResultGrid do        begin
  Cells[0,0]:= 'Stk#';  ColWidths[0]:=31;
  Cells[1,0]:= ' Size'; ColWidths[1]:=42;
  Cells[2,0]:= 'Waste'; ColWidths[2]:=42;
  Cells[3,0]:= '    Cutting Layouts';
  ColWidths[3]:=1000;           end;

    with ArrBoxGrid do        begin
  Cells[0,0]:='#';      ColWidths[0]:=40;
  Cells[1,0]:=' Size';  ColWidths[1]:=40;
  Cells[2,0]:='Stk#';
  for i:= 1 to RowCount - 1 do
  Cells[0,i]:= IntToStr(i);     end;

    with ArrCntGrid do        begin
  Cells[0,0]:='#';
  Cells[1,0]:=' Size';  ColWidths[1]:=40;
  Cells[2,0]:='Lay#';
  Cells[3,0]:='Parts';  ColWidths[3]:=34;
  Cells[4,0]:='Waste';  ColWidths[4]:=42;
  for i:= 1 to RowCount - 1 do
  Cells[0,i]:= IntToStr(i);     end;
end;
{----------------------------------------------------}
procedure TMainForm.ClearResultGrids;
var i,j : Integer;
begin
    with ArrBoxGrid do                     begin
  for i:= 1 to RowCount-1 do
  for j:= 1 to ColCount-1 do Cells[j,i]:='';
  Refresh;                                   end;

    with ArrCntGrid do                     begin
  for i:= 1 to RowCount-1 do
  for j:= 1 to ColCount-1 do Cells[j,i]:='';
  Refresh;                                   end;

    with ResultGrid do                     begin
  for i:= 1 to RowCount-1 do
  for j:= 0 to ColCount-1 do Cells[j,i]:='';
  Refresh;                                   end;
end;
{----------------------------------------------------}
procedure TMainForm.DefaultTotals(C,B :boolean);
begin
  if C then StockTotEd.Text:='Sum';
  if B then PartTotEd.Text:='Sum';
  ContLab.Caption:='Stocks Used:';  {defaults}
  LeftLab.Caption:='Parts Left:';
  CritLab.Caption:='Criterion:';
  UtilLab.Caption:='Utilization,%:';
  VolLab.Caption:= 'Used Length:';
  CostLab.Caption:='Used Cost:';
  WstLab.Caption:= 'Total Waste:';
  LastNoLab.Caption:= 'Last Stock No:';
  LastWstLab.Caption:='Last Stock Wst:';
  LayCutLab.Caption:= 'Layouts/Cuts:';
  SawLab.Caption:= 'Saw gap:';
  EndLab.Caption:= 'End gap:';
  ErrLab.Caption:='Error#';
end;
{----------------------------------------------------}
procedure TMainForm.DefaultCells(C,B :boolean);
var i : Integer;
begin
    if C then  with CntGrid do   begin
  for i:= 1 to ColCount - 1 do begin
  Cells[i,1]:= '';
  Cells[i,2]:= '';               end;
  Cells[1,1]:= '1';
  Cells[1,2]:= '1';                end;

    if B then  with BoxGrid do   begin
  for i:= 1 to ColCount - 1 do begin
  Cells[i,1]:= '';
  Cells[i,2]:= '';               end;
  Cells[1,1]:= '1';
  Cells[1,2]:= '1';                end;
end;
{----------------------------------------------------}
procedure TMainForm.ClearY1DCallVarsDLL;
var i : integer;
begin
    for i:= A1 to CntGrMax+1 do           begin
  StockGrLth[i]:=0;  StockGrCst[i]:=0;
  StockGrQty[i]:=0;                         end;

    for i:= A1 to BoxGrMax+1 do           begin
  PartGrLth[i]:=0;   PartGrMrkID[i]:=0;
  PartGrQty[i]:=0;                          end;

  StockGrNmb:=0; PartGrNmb:=0;
  StockNumb:=0;  PartNumb:=0;    {Clear all output vars}
  Critsum:=0;    Effsum:=0;
  StockSum:=0;   PartSum:=0;
  LengthSum:=0;  WasteSum:=0;  CostSum:=0;
  LastStockNo:=0;  LastParts:=0;
  LastLength:=0; LastWaste:=0; LastCost:=0;
  PatternSum:=0; LayoutSum:=0; LayoutCuts:=0;
  ReservOut1:=0; ReservOut2:=0;

    for i:= A1 to CntMax+1 do        begin
  StockGrNo[i]:=0;   StockWaste[i]:=0;
  StockLayNo[i]:=0;  StockPatNo[i]:=0;
  StockParts[i]:=0;
  StockLength[i]:=0; StockCost[i]:=0;  end;

    for i:= A1 to BoxMax+1 do        begin
  PartGrNo[i]:=0;    PartStockNo[i]:=0;
  PartLength[i]:=0;  PartMarkID[i]:=0; end;

  ClearResultGrids;
end; {ClearY1DCallVarsDLL}
{----------------------------------------------------}
function TMainForm.ReadGridGroups :boolean;
var i, CellMin  :Integer;
begin
  Result:=true; {default}        {Read input data from the grids}
    i:=0;  CellMin:=1;           {!Any integer allowed for tests}
        if RadioButtonSRS.Checked then CellMin:=0;
    with CntGrid do                         Begin
  while ((i < ColCount-1) and (i < CntGrMax)
     and (StrToIntDef(Cells[i+1,1],CellBad) >= CellMin)
     and (StrToIntDef(Cells[i+1,2],CellBad) >= CellMin))
  do                                  begin Inc(i);
  StockGrLth[i]:= StrToInt(Cells[i,1]);
  StockGrCst[i]:= StockGrLth[i]*CostOptim;
                   {Real cost input doesn't present in this demo}
  StockGrQty[i]:= StrToInt(Cells[i,2]); end;

  StockGrNmb:=i;
  if (WarnMsgs and (i > CntGrMax)) then  begin
  ShowMessage('Too many stock groups');
  Result:=false; Exit;                     end;

  while (i < ColCount-1) do              begin {Empty rest cells}
  Inc(i); Cells[i,1]:=''; Cells[i,2]:='';  end
                                              End;
    i:=0;  CellMin:=1;
    with BoxGrid do                         Begin
  while ((i < ColCount-1) and (i < BoxGrMax)
     and (StrToIntDef(Cells[i+1,1],CellBad) >= CellMin)
     and (StrToIntDef(Cells[i+1,2],CellBad) >= CellMin))
  do                                 begin Inc(i);
  PartGrLth[i]:= StrToInt(Cells[i,1]);
  PartGrMrkID[i]:= 0; {Cells[i,x] do not present}
  PartGrQty[i]:= StrToInt(Cells[i,2]); end;

  PartGrNmb:=i;
  if (WarnMsgs and (i > BoxGrMax)) then  begin
  ShowMessage('Too many part groups');
  Result:=false; Exit;                     end;

  while (i < ColCount-1) do              begin {Empty rest cells}
  Inc(i); Cells[i,1]:=''; Cells[i,2]:='';  end
                                              End;
end; {ReadGridGroups}

{---- Converting group arrays to Stock/Part Length Line Arrays ---}
function TMainForm.UnGroupInput :boolean;
var i,j,k :Integer;                        {for both DLL CallModes}
begin
  Result:=true; {default}
  i:=0; j:=0;                              {Stock group processing}
  repeat Inc(j); k:=StockGrQty[j];
  if (WarnMsgs and (k < 1)) then         begin
  ShowMessage('Error: Stock input Qty < 1');
  Result:=false; Exit;                     end;

    repeat  if k > 0 then                begin
      Dec(k); Inc(i);
        if i <= CntMax then         begin
      StockLength[i]:= StockGrLth[j];
      StockCost[i]:= StockGrCst[j];   end; end;
    until ((k <= 0) or (i >= CntMax));

  if (WarnMsgs and (k > 0)) then begin
  ShowMessage('Too many Stocks');
  Result:=false;  Exit;            end;
  until (j >= StockGrNmb);
  StockNumb:=i; {just for CallMode-1}

  if (WarnMsgs and (i < 1)) then   begin
  ShowMessage('No Stocks defined');
  Result:=false;  Exit;              end;

  i:=0; j:=0;                               {Part group processing}
  repeat Inc(j); k:=PartGrQty[j];
  if (WarnMsgs and (k < 1)) then         begin
  ShowMessage('Error: Part input Qty < 1');
  Result:=false; Exit;                     end;

    repeat  if k > 0 then                begin
      Dec(k); Inc(i);
        if i <= BoxMax then         begin
      PartLength[i]:= PartGrLth[j];
      PartMarkID[i]:= PartGrMrkID[j]; end; end;
    until ((k <= 0) or (i >= BoxMax));

  if (WarnMsgs and (k > 0)) then begin
  ShowMessage('Too many Parts');
  Result:=false; Exit;             end;
  until (j >= PartGrNmb);
  PartNumb:=i; {just for CallMode-1}

  if (WarnMsgs and (i < 1)) then begin
  ShowMessage('No Parts defined');
  Result:=false; Exit;             end;

end; {UnGroupInput}

{----------------------------------------------------}
procedure TMainForm.RunButtonClick(Sender: TObject);
var i: lint;
begin
  if RadioButtonSRS.Checked then SRSCallMode:= 1
                            else SRSCallMode:= 0; {default}

  if RadioButtonB.Checked then CallMode:= 1
                          else CallMode:= 0; {default}
  ClearY1DCallVarsDLL;
  DefaultTotals(true,true);
  if not ReadGridGroups then Exit;

  case CallMode of
   0: begin   {Groupped Input}
  if not UnGroupInput then Exit; {defines Stock/Part/Numb/Length}
  StockGrLth[0]:= StockGrNmb;  StockGrLth[StockGrNmb+1]:= StockCheck;
  StockGrCst[0]:= StockGrNmb;  StockGrCst[StockGrNmb+1]:= StockCheck;
  StockGrQty[0]:= StockGrNmb;  StockGrQty[StockGrNmb+1]:= StockCheck;
  PartGrLth[0]:=  PartGrNmb;   PartGrLth[PartGrNmb+1]:= PartCheck;
  PartGrMrkID[0]:= PartGrNmb;  PartGrMrkID[PartGrNmb+1]:= PartCheck;
  PartGrQty[0]:=  PartGrNmb;   PartGrQty[PartGrNmb+1]:= PartCheck;
        end;
   1: begin   {LineArray Input}
  if not UnGroupInput then Exit; {defines Stock/Part/Numb/Length}
  StockLength[0]:=StockNumb;   StockLength[StockNumb+1]:=StockCheck;
  StockCost[0]:=  StockNumb;   StockCost[StockNumb+1]:=  StockCheck;
  PartLength[0]:= PartNumb;    PartLength[PartNumb+1]:= PartCheck;
  PartMarkID[0]:= PartNumb;    PartMarkID[PartNumb+1]:= PartCheck;
        end;
  end; {case}

  ErrorNumb:=0; {0} {DLL and Unit procedure calls must be similar}

  WaitMsgForm.Caption:= RegCustomer;
{$IFDEF DLLmode}
  WaitMsgForm.Caption:= WaitMsgForm.Caption +':  '+
  IntToStr(BoxMax) +'/'+ IntToStr(BoxGrMax) +' : '+
  IntToStr(CntMax) +'/'+ IntToStr(CntGrMax); {Array dimensions only!}
{$ELSE DLLmode}
    if BoxMxMsg*CntMxMsg > 0 then {If defined after the 1-st call}
  WaitMsgForm.Caption:= WaitMsgForm.Caption +':  '+
  IntToStr(BoxMxMsg) +'/'+ IntToStr(BoxGrMxMsg) +' : '+
  IntToStr(CntMxMsg) +'/'+ IntToStr(CntGrMxMsg);
{$ENDIF DLLmode}

  WaitMsgForm.Show;
  Application.ProcessMessages;

  if SRSCallMode = 0 then
  case CallMode of
   0:    {Groupped Input}
 Y1DPackG5(ErrorNumb, ErrorMsgs, RegCustomer, RegPassword,
 {input}  CostOptim, IgnoreLast,                       {input settings}
          Intensity, ReduceLays, PrefShort,
          DiffStocks, DiffPieces, MaxPieces,
          StockBundle, ReusLength, ReusAbility,
          GapItIt, GapItEnd, GapGripEnd,
          OptimTime, IterMult, LayByMark,
          RunMsgMode, ReservInp4, ReservInp3,
          ReservInp2, ReservInp1,
          StockGrLth, StockGrCst, StockGrQty,            {input arrays}
          PartGrLth, PartGrMrkID, PartGrQty,
 {output} Critsum, Effsum,                              {output totals}
          StockSum, PartSum, LengthSum, WasteSum, CostSum,
          LastStockNo, LastParts, LastLength, LastWaste, LastCost,
          PatternSum, LayoutSum, LayoutCuts, {total layout/cut numbers}
          ReservOut3, ReservOut2, ReservOut1,
          StockGrNo, PartGrNo,                {two output extra arrays}
          PartStockNo, StockLayNo, StockPatNo,   {output common arrays}
          StockParts, StockWaste);

   1:    {LineArray Input}
 Y1DPackB5(ErrorNumb, ErrorMsgs, RegCustomer, RegPassword,
 {input}  CostOptim, IgnoreLast,                       {input settings}
          Intensity, ReduceLays, PrefShort,
          DiffStocks, DiffPieces, MaxPieces,
          StockBundle, ReusLength, ReusAbility,
          GapItIt, GapItEnd, GapGripEnd,
          OptimTime, IterMult, LayByMark,
          RunMsgMode, ReservInp4, ReservInp3,
          ReservInp2, ReservInp1,
          StockLength, StockCost,                        {input arrays}
          PartLength, PartMarkID,
 {output} Critsum, Effsum,                              {output totals}
          StockSum, PartSum,
          LengthSum, WasteSum, CostSum,
          LastStockNo, LastParts,
          LastLength, LastWaste, LastCost,
          PatternSum, LayoutSum, LayoutCuts, {total layout/cut numbers}
          ReservOut3, ReservOut2, ReservOut1,
          PartStockNo, StockLayNo, StockPatNo,   {output common arrays}
          StockParts, StockWaste);
  end {case}
                        {Stock Range Scan mode / Groupped Input}
  else {SRSCallMode = 1}                                         begin
                        {Check standard for Qty input in SRS mode}
     if (StockGrQty[1]+StockGrQty[2]+StockGrQty[3] <> 0) then begin
       ShowMessage('Incorrect Qty input for Y1DScanG() - SRS mode');
       WaitMsgForm.Hide;  Exit;                                 end;

 Y1DScanG5(ErrorNumb, ErrorMsgs, RegCustomer, RegPassword,
 {input}  CostOptim, IgnoreLast,
          Intensity, ReduceLays, PrefShort,
          DiffStocks, DiffPieces, MaxPieces,
          StockBundle, ReusLength, ReusAbility,
          GapItIt, GapItEnd, GapGripEnd,
          OptimTime, IterMult, LayByMark,
          RunMsgMode, ReservInp4, ReservInp3,
          ReservInp2, ReservInp1,
          StockGrLth, StockGrCst, StockGrQty, {srs}
          PartGrLth, PartGrMrkID, PartGrQty,
 {output} Critsum, Effsum,
          StockSum, PartSum, LengthSum, WasteSum, CostSum,
          LastStockNo, LastParts, LastLength, LastWaste, LastCost,
          PatternSum, LayoutSum, LayoutCuts,
          ReservOut3, ReservOut2, ReservOut1,
          StockGrNo, PartGrNo,
          PartStockNo, StockLayNo, StockPatNo,
          StockParts, StockWaste);
                                {Results to 5-th stock column tempo}
  CntGrid.Cells[5,1]:= IntToStr(StockGrLth[1]);
    if LastStockNo = 0  {No Last stock presents}
  then CntGrid.Cells[5,2]:= IntToStr(StockSum)
  else CntGrid.Cells[5,2]:= IntToStr(StockSum+1);                end;

  WaitMsgForm.Hide;

  If ErrorNumb > 0 then                                        begin
  ShowMessage('DLL reports error ' + IntToStr(ErrorNumb)); Exit; end;

  if (CallMode = 0) then  {Y1D BoxNumb/CntNumb}      begin
  PartNumb:=PartStockNo[0]; StockNumb:=StockLayNo[0];  end;

  if ((CallMode = 1) and ((PartNumb <> PartStockNo[0]) {Check return}
                      or (StockNumb <> StockLayNo[0]))) then begin
  ShowMessage('DLL returns error Part/Stock Number');  Exit;   end;

  if (CallMode = 0) then                         {Return Code checks}
  if ((PartGrNo[PartNumb+1] <> StockCheck + PartCheck)
   or (StockGrNo[StockNumb+1] <> StockCheck + PartCheck))
  then ShowMessage('DLL transfer check ReturnCode error');

  if ((PartStockNo[PartNumb+1] <> StockCheck + PartCheck)
   or (StockLayNo[StockNumb+1] <> StockCheck + PartCheck)
   or (StockPatNo[StockNumb+1] <> StockCheck + PartCheck)
   or (StockParts[StockNumb+1] <> StockCheck + PartCheck)
   or (StockWaste[StockNumb+1] <> StockCheck + PartCheck))
  then ShowMessage('DLL transfer check ReturnCode error');

  OpenLayouts; {Get solution from Y1DPack procedure return arguments}

    with ArrBoxGrid do    {display main resulting arrays}     begin
  for i:=1 to PartNumb do Cells[1,i]:=IntToStr(PartLength[i]);
  for i:=1 to PartNumb do Cells[2,i]:=IntToStr(PartStockNo[i]); end;

    with ArrCntGrid do  for i:=1 to StockNumb do   begin
  if SRSCallMode = 1
  then Cells[1,i]:=IntToStr(StockGrLth[1])    {Stock Range Scan case}
  else Cells[1,i]:=IntToStr(StockLength[i]); {Common Stock List case}
  Cells[2,i]:=IntToStr(StockLayNo[i]);
{ Cells[2,i]:=IntToStr(StockPatNo[i]); {var}
  Cells[3,i]:=IntToStr(StockParts[i]);
  Cells[4,i]:=IntToStr(StockWaste[i]);               end;

  StockTotEd.Text:=IntToStr(StockNumb);     {display solution totals}
  PartTotEd.Text:= IntToStr(PartNumb);
  ContLab.Caption:='Stocks Used:  ' + IntToStr(StockSum);
  LeftLab.Caption:='Parts Left:  ' + IntToStr(PartNumb - PartSum);
  CritLab.Caption:='Criterion:  ' + FloatToStr(Critsum/1000);
  UtilLab.Caption:='Utilization,%:  ' + FloatToStr(Effsum/1000);
  VolLab.Caption:= 'Used Length:  ' + IntToStr(LengthSum);
  CostLab.Caption:='Used Cost:  ' + IntToStr(CostSum);
  WstLab.Caption:= 'Total Waste:  ' + IntToStr(WasteSum);
  LastNoLab.Caption:= 'Last Stock No:  ' + IntToStr(LastStockNo);
  LastWstLab.Caption:='Last Stock Wst:  ' + IntToStr(LastWaste);
  LayCutLab.Caption:= 'Layouts/Cuts:  ' + IntToStr(LayoutSum)
                                 + '/' + IntToStr(LayoutCuts);
  SawLab.Caption:= 'Saw gap:  ' + IntToStr(GapItIt);
  if GapGripEnd > 0  then
  EndLab.Caption:= 'Grip End:  ' + IntToStr(GapGripEnd) else
  EndLab.Caption:= 'End gap:  ' + IntToStr(GapItEnd);
  ErrLab.Caption:='Error#  ' + IntToStr(ErrorNumb);

end; {RunButtonClick}

{-------------------- PartStockNo[array] => to usual layout view ---}
procedure TMainForm.OpenLayouts;
var RNo,CNo,BNo,Used :Integer;  LayStr :string;
begin
  RNo:=0; CNo:=0;  with ResultGrid do
 Repeat Inc(RNo); {next grid line}
   repeat Inc(CNo);
    BNo:=0;       {seek for the first used stock}
    repeat Inc(BNo)
    until ((BNo > PartNumb) or (PartStockNo[BNo]=CNo));
   until ((BNo <= PartNumb) or (CNo >= StockNumb));

   if (BNo <= PartNumb) then    {stock is used}         Begin
   Used:=0; LayStr:=' '; {layout string - initial}
   for BNo:=1 to PartNumb do if PartStockNo[BNo]=CNo then
  case CallMode of
  0: LayStr:= LayStr + IntToStr(PartGrLth[PartGrNo[BNo]]) +'   ';
  1: LayStr:= LayStr + IntToStr(PartLength[BNo]) +'   ';
  end;
   for BNo:=1 to PartNumb do if PartStockNo[BNo]=CNo then {Calc Used}
  case CallMode of
  0: Used:= Used + PartGrLth[PartGrNo[BNo]];
  1: Used:= Used + PartLength[BNo];
  end;
     Cells[0,RNo]:= IntToStr(CNo); {RNo?}
     Cells[3,RNo]:= LayStr;
  case CallMode of
  0: Cells[1,RNo]:= IntToStr(StockGrLth[StockGrNo[CNo]]);
  1: Cells[1,RNo]:= IntToStr(StockLength[CNo]);
  end;
  case CallMode of
  0: Cells[2,RNo]:= IntToStr(StockGrLth[StockGrNo[CNo]] - Used);
  1: Cells[2,RNo]:= IntToStr(StockLength[CNo] - Used);
  end;                                                    End;
 Until ((RNo >= RowCount - 1) or (CNo >= StockNumb));

  if ((RNo >= ResultGrid.RowCount - 1) and (CNo < StockNumb))
  then ShowMessage('Not enough table rows to '
           + #13 + 'display all result data');
end; {OpenLayouts}
{----------------------------------------------------}
procedure TMainForm.StockButtonClick(Sender: TObject);
begin
  DefaultCells(true,false); DefaultTotals(true,false);
end;
procedure TMainForm.PartButtonClick(Sender: TObject);
begin
  DefaultCells(false,true); DefaultTotals(false,true);
end;
{----------------------------------------------------}
procedure TMainForm.VerButtonClick(Sender: TObject);
begin
{$IFDEF DLLmode}
  Y1DisplayVersion;
{$ENDIF DLLmode}
end;
procedure TMainForm.RunTextsButtonClick(Sender: TObject);
begin
{$IFDEF DLLmode}
  Y1DRunMessage('NewCaption', 'NewOptRun',
                'NewEscAbort', 'NewCritTime');
  Y1DRunMessageSRS('NewCaptionRS', 'NewOptRunRS',
                'NewEscAbortRS', 'NewCritTimeRS');
  ShowMessage('Run message caption/text modified');
{$ENDIF DLLmode}
end;
{----------------------------------------------------}
procedure TMainForm.CloseButClick(Sender: TObject);
begin
  Close;
end;
{----------------------------------------------------}
procedure TMainForm.InputExample(IniExample :integer);
begin
  DefaultSettings;
  DefaultCells(true,true);
  ExampleCells(IniExample);
end;
{----------------------------------------------------}
procedure TMainForm.FormCreate(Sender: TObject);
begin
  CntGrid.ColCount:= CntGrMax+5; {+1 Col/Row for fixed/heads}
  BoxGrid.ColCount:= BoxGrMax+5;
  ArrBoxGrid.RowCount:=BoxMax+1;
  ArrCntGrid.RowCount:=CntMax+1;
  ResultGrid.RowCount:=CntMax+1;
  GridHeaders;
  DefaultTotals(true,true);
  IniExUpDown.Position:=IniExample;    {default example No}
    if (IniExample < 0) then RadioButtonSRS.Checked:= true
    else RadioButtonG.Checked:= true;  {default CallMode-0}
  InputExample(IniExample);
{$IFDEF DLLmode}
  RunButton.Caption:= 'Call  DLL';
{$ELSE DLLmode}
  VerButton.Enabled:= false;
  RunTextsButton.Enabled:= false;
{$ENDIF DLLmode}
end;
{----------------------------------------------------}
procedure TMainForm.IniExUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
  if (IniExUpDown.Position < 0) then RadioButtonSRS.Checked:= true
  else if (IniExample{old} < 0) then RadioButtonG.Checked:= true;

  IniExample:=IniExUpDown.Position;
  InputExample(IniExample);
end;
{----------------------------------------------------}
procedure TMainForm.ExampleCells(IniExample :integer);   var i :lint;
begin
{Note: all sizes must be multiplied by accuracy factor}
 case IniExample of
-1: begin               {Stock Range Scan mode example only!}
    with BoxGrid do
  for i:= 1 to 5 do           begin
  Cells[i,1]:= IntToStr(123-20*i);      {Length = 103 ... 23}
  Cells[i,2]:= IntToStr(2+i);   end;
    with CntGrid do     begin
  Cells[1,1]:= '600';
  Cells[2,1]:= '10';
  Cells[3,1]:= '300';
  Cells[1,2]:= '0';
  Cells[2,2]:= '0';
  Cells[3,2]:= '0';       end;
    end;
 0: begin
    with BoxGrid do       begin        {Standard demo sample}
  Cells[1,1]:= IntToStr(162);          {Length = 162, 94, 48}
  Cells[1,2]:= IntToStr(5);
  Cells[2,1]:= IntToStr(94);
  Cells[2,2]:= IntToStr(5);
  Cells[3,1]:= IntToStr(48);
  Cells[3,2]:= IntToStr(10);
                            end;
    with CntGrid do       begin
  Cells[1,1]:= IntToStr(350);           {Length = 350}
  Cells[1,2]:= IntToStr(10);            {Number}
                            end;
    end;
 1: begin
    with BoxGrid do
  for i:= 1 to 5 do           begin
  Cells[i,1]:= IntToStr(123-20*i);      {Length = 103 ... 23}
  Cells[i,2]:= IntToStr(2+i);   end;
    with CntGrid do
  for i:= 1 to 3 do           begin     {435 x3}
  Cells[i,1]:= IntToStr(435-50*i);      {Length = 385, 335, 285}
  Cells[i,2]:= IntToStr(5);     end;    {Number}
    end;
 2: begin
    with BoxGrid do
  for i:= 1 to 5 do           begin
  Cells[i,1]:= IntToStr(1230-200*i);    {Length = 1030 ... 230}
  Cells[i,2]:= IntToStr(2+i);   end;
    with CntGrid do
  for i:= 1 to 1 do           begin     {4350 x1}
  Cells[i,1]:= IntToStr(4350-500*i);    {Length = 3850}
  Cells[i,2]:= IntToStr(10);    end;    {Number}
    end;
 3: begin
    with BoxGrid do
  for i:= 1 to 5 do           begin
  Cells[i,1]:= IntToStr(12300-2000*i);  {Length = 10300 ... 2300}
  Cells[i,2]:= IntToStr(2+i);   end;
    with CntGrid do
  for i:= 1 to 3 do           begin     {43500 x3}
  Cells[i,1]:= IntToStr(43500-5000*i);  {Length = 38500, 33500, 28500}
  Cells[i,2]:= IntToStr(5);     end;    {Number}
    end;
 4: begin
    with BoxGrid do
  for i:= 1 to 5 do           begin
  Cells[i,1]:= IntToStr(12300-1000*i);  {Length = 11300 ... 7300}
  Cells[i,2]:= IntToStr(2+i);   end;
    with CntGrid do
  for i:= 1 to 3 do           begin
  Cells[i,1]:= IntToStr(22000-2500*i);  {Length = 19500, 17000, 14500}
  Cells[i,2]:= IntToStr(5);     end;    {Number}
    end;
 5: begin           Intensity:=1;       {Mass BoxMax, CntMax numbers}
    with BoxGrid do
  for i:= 1 to 5 do              begin
  Cells[i,1]:= IntToStr(123-20*i);      {Length = 103 ... 23}
  Cells[i,2]:= IntToStr(4009-3*i); end;
    with CntGrid do
  for i:= 1 to 3 do           begin     {435 x3}
  Cells[i,1]:= IntToStr(435-50*i);      {Length = 385, 335, 285}
  Cells[i,2]:= IntToStr(3333);  end;    {Number}
    end;
 6: begin
    with BoxGrid do
  for i:= 1 to 6 do           begin
  Cells[i,1]:= IntToStr(3300-500*i);      {Length = 6300 ... 2300}
  Cells[i,2]:= IntToStr(1200+i*600);   end;
    with CntGrid do
  for i:= 1 to 6 do           begin
  Cells[i,1]:= IntToStr(10000-800*i);     {Length = 9000 ... 7000}
  Cells[i,2]:= IntToStr(800);     end;    {Number = 800*6}
    end;
 7: begin
    with BoxGrid do
  for i:= 1 to 80 do          begin  //80
  Cells[i,1]:= IntToStr(234-2*i);
  Cells[i,2]:= IntToStr(10+i);  end; //20
    with CntGrid do
  for i:= 1 to 100 do         begin  //100
  Cells[i,1]:= IntToStr(435-1*i);
  Cells[i,2]:= IntToStr(10);   end;  //50
    end;
  end;{case}
end;
{----------------------------------------------------}
procedure TMainForm.DefaultSettings;
begin
  ErrorMsgs:= 2; {2} {0/1 = Off/On DLL Error Messages, 2 -All info}
  CostOptim:= 0; {0/1 = false/true}       //??
  IgnoreLast:=1; {0/1 = false/true}
  Intensity:= 5; {0..5/8/10; 5 = default}
  ReduceLays:=1; {0..3; 0-1 = defaults}   //??
  PrefShort:= 0; {-5..5; 0 = default}
  DiffStocks:=0; { >=0;  0 = default}
  DiffPieces:=0; { >=0;  0 = default}
  MaxPieces:= 0; { >=0;  0 = default}    //??
  StockBundle:=0;{ >=0;  0 = default}
  ReusLength:=0; { >=0;  0 = default, integer!}
  ReusAbility:=0;{ >=0;  0 = default}
  GapItIt:=0;    { >=0;  all integers..!}
  GapItEnd:=0;   { >=0;  non usable end zone case}
  GapGripEnd:=0; { >=0;  gripping case}
{Note: all sizes must be multiplied by accuracy factor}
  OptimTime:=555; {ms}
  IterMult:= 20; {20 = default}
  LayByMark:=0;  {0 = default}
  RunMsgMode:=2; {0 - Off; 1 - On; 2 - On + Esc abort}
  ReservInp1:=0; ReservInp2:=0;
  ReservInp3:=0; ReservInp4:=0;
end;
{----------------------------------------------------}

initialization

  RegCustomer:='Astrokettle Algorithms';  IniExample:=0;
  RegPassword:= 5555555; {'Astrokettle Algorithms'}

end.

